package com.example.adventurepocket;

import android.util.Log;
import java.util.Random;

class EnemyPool extends GameEntity
{

    Enemy[] randomEnemyGamePool;

    int currentEnemyInLine;
    int poolsSpawned = 0;
    boolean endOfPool = false;
    // Enemy Pool will Create an Array of 10 Enemies to use in our Fight Action it will set up the first fight as a Goblin, and the Last as the Goblin Mage, with the rest being any of out enemies beisdes the boss or MiniBoss.
    EnemyPool(int _length)
    {
        SpawnPool(_length);
    }

    // RandomEnemy will pick a random enemy to fill the spot in our EnemyPools, this is badly done and I need to redo it, but It works for testing as is.
    // Once the EnemyManager is added in, this should move to that area and cleaned up a lot
    private Enemy RandomEnemy()
    {
        Enemy[] randomEnemyPool;
        randomEnemyPool = new Enemy[3];

        // The 3 Basic Enemies in the game, so we can build a random list of enemies for battle.
        randomEnemyPool[0] = new Enemy.Goblin();
        randomEnemyPool[1] = new Enemy.GoblinRogue();
        randomEnemyPool[2] = new Enemy.GoblinRanger();

        Random rand = new Random();
        int a = rand.nextInt(randomEnemyPool.length);
        return randomEnemyPool[a];

    }

    void CheckEnemyAtPos(int _pos)
    {
        Enemy tmpEnemy = randomEnemyGamePool[_pos];
        Log.i("FightScreen - Details", " Name of Enemy at " + _pos + " Position - " + tmpEnemy.name);
        Log.i("FightScreen - Details", " Attack of Enemy at " + _pos + " Position - " + tmpEnemy.stats.GetAttack());
        Log.i("FightScreen - Details", " Defence of Enemy at " + _pos + " Position - " + tmpEnemy.stats.GetDefense());
        Log.i("FightScreen - Details", " Health of Enemy at " + _pos + " Position - " + tmpEnemy.stats.GetCurrentHealth() + "/" + tmpEnemy.stats.GetMaxHealth());

    }
    // This will, if the currentEnemyInLine is greater or equal to 10, reset that back to 0, and Spawn a New pool, intended for when the players beats a dungeon
    void SpawnPool(int _length)
    {
        Log.i("Debugging", "EnemyPool Started");
        randomEnemyGamePool = new Enemy[_length];
        randomEnemyGamePool[0] = new Enemy.Goblin();
        for (int i = 1; i < randomEnemyGamePool.length; i++)
        {
            randomEnemyGamePool[i] = RandomEnemy();
            randomEnemyGamePool[i].stats.SetPoolsPassed(poolsSpawned);

        }
        randomEnemyGamePool[4] = new Enemy.GoblinFighter();
        randomEnemyGamePool[_length - 1] = new Enemy.GoblinMage();
        endOfPool = true;
        poolsSpawned++;
    }

    void IncreaseEnemyInLine()
    {
        currentEnemyInLine++;
        if(currentEnemyInLine >= 10)
        {
            currentEnemyInLine = 0;

            SpawnPool(10);

        }
    }
}












