package com.example.adventurepocket;

import java.sql.Time;

class EntityManager extends GameEntity
{
    private static EntityManager iEntityManager = null;
    Creature pet;
    CreatureManager iCreatureManager;
    EnemyManager iEnemyManager;
    TimeOfDay iTime;

    private EntityManager()
    {
        iTime = TimeOfDay.TimeofDay();
        iEnemyManager = EnemyManager.iEnemyManager();

        iCreatureManager = CreatureManager.iCreatureManager();
        pet = iCreatureManager.pet;
    }
    static EntityManager iEntityManager()
    {
        // To ensure only one instance is created
        if (iEntityManager == null)
        {
            iEntityManager = new EntityManager();
        }
        return iEntityManager;
    }

}
