package com.example.adventurepocket;

import android.util.DisplayMetrics;
import android.view.View;

import androidx.annotation.LayoutRes;
import androidx.appcompat.app.AppCompatActivity;


import java.sql.Time;

class GameSetup extends AppCompatActivity
{
    EntityManager mEntityManger;
    TimeOfDay mTimeOfDay;
    void Managers()
    {
        mEntityManger = EntityManager.iEntityManager();
        mTimeOfDay = TimeOfDay.TimeofDay();
    }

    void makeFullScreen()
    {
        getWindow().getDecorView().setSystemUiVisibility(
                View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                        | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                        | View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                        | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                        | View.SYSTEM_UI_FLAG_FULLSCREEN
                        | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY);
        Managers();
    }

    class Popup {

        float popupWidth;
        float popupHeight;
        int dmWidth;
        int dmHeight;

        void PopUpCreate(float _popWidth, float _popHeight, @LayoutRes int layoutResID)
        {

            setContentView(layoutResID);
            popupWidth = _popWidth;
            popupHeight = _popHeight;

            DisplayMetrics dm = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics(dm);

            dmWidth = dm.widthPixels;
            dmHeight = dm.heightPixels;

            getWindow().setLayout((int)(dmWidth * popupWidth),(int)(dmHeight * popupHeight));
        }

    }

}