package com.example.adventurepocket;

import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.PopupWindow;
import android.widget.TextView;

import androidx.constraintlayout.widget.ConstraintLayout;

//is actually shop activity but i messed up on the name

public class ShopScreen extends GameSetup implements View.OnTouchListener {

    ShopThread shopThread;
    ShopManager shopState;

    ShopKeeper shopKeeper = ShopKeeper.iShopKeeper();

    static boolean buttonsOn = true;
    static boolean flexButtonOnSell = true;


    ImageView sell;
    ImageView upgrade;
    public TextView inventorySlot1;
    String option1Cost;
    public TextView inventorySlot2;
    String option2Cost;
    public TextView inventorySlot3;
    String option3Cost;
    public TextView inventorySlot4;
    String option4Cost;
    public TextView inventorySlot5;
    String option5Cost;
    public TextView inventorySlot6;
    String option6Cost;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_shop);
        makeFullScreen();

        shopThread = new ShopThread();
        shopState = new ShopManager();
        shopState.activity = this;
        shopThread.activateShopThread(shopState);

        option1Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[0].GetCost());
        option2Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[1].GetCost());
        option3Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[2].GetCost());
        option4Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[3].GetCost());
        option5Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[4].GetCost());
        option6Cost = Integer.toString(shopKeeper.keeperInventory.shopInventory[5].GetCost());

        sell = (ImageView) findViewById(R.id.image_sell);
        sell.setOnTouchListener(this);

        upgrade = (ImageView) findViewById(R.id.image_upgrades);
        upgrade.setOnTouchListener(this);

        inventorySlot1 = (TextView) findViewById(R.id.text_shop_inv_slot1);
        inventorySlot1.setOnTouchListener(this);

        inventorySlot2 = (TextView) findViewById(R.id.text_shop_inv_slot2);
        inventorySlot2.setOnTouchListener(this);

        inventorySlot3 = (TextView) findViewById(R.id.text_shop_inv_slot3);
        inventorySlot3.setOnTouchListener(this);

        inventorySlot4 = (TextView) findViewById(R.id.text_shop_inv_slot4);
        inventorySlot4.setOnTouchListener(this);

        inventorySlot5 = (TextView) findViewById(R.id.text_shop_inv_slot5);
        inventorySlot5.setOnTouchListener(this);

        inventorySlot6 = (TextView) findViewById(R.id.text_shop_inv_slot6);
        inventorySlot6.setOnTouchListener(this);
    }


    @Override
    public boolean onTouch(View v, MotionEvent event) {
        if (buttonsOn) {
            if (event.getAction() == MotionEvent.ACTION_DOWN) {
                switch (v.getId()) {
                    case R.id.image_sell:
                        Log.i("shop_info", "sell down");
                        //on touch, when its in buy state, change it to sell state

                        switch (shopState.GetState()) {
                            case Buy:
                                sell.setImageResource(R.drawable.sell);
                                shopState.changeState(EShopState.Sell);
                                Log.i("shop_info", "sell down");
                                break;
                            case Sell:
                                sell.setImageResource(R.drawable.buy);
                                shopState.changeState(EShopState.Buy);
                                Log.i("shop_info", "buy down");
                                break;
                            case Upgrade:
                                break;
                        }
                        return true;

                    case R.id.image_upgrades:
                        Log.i("shop_info", "upgrade down");
                        shopState.changeState(EShopState.Upgrade);
                        return true;

                    case R.id.text_shop_inv_slot1:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[0].GetName()));
                        return true;

                    case R.id.text_shop_inv_slot2:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[1].GetName()));
                        return true;

                    case R.id.text_shop_inv_slot3:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[2].GetName()));
                        return true;

                    case R.id.text_shop_inv_slot4:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[3].GetName()));
                        return true;

                    case R.id.text_shop_inv_slot5:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[4].GetName()));
                        return true;

                    case R.id.text_shop_inv_slot6:
                        shopKeeper.TakePlayerGoldandGiveItem(shopKeeper.keeperInventory.FindItemByName(shopKeeper.keeperInventory.shopInventory[5].GetName()));
                        return true;

                }
            }
            else
                return false;

        }
        return false;
    }

    public void SwitchInventoryUI(EShopState state) {
        //switch to the Inventory activity, and have it set to whichever option the player is choosing
        switch (shopState.GetState()) {
            case Buy:
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot1, 0);
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot2, 1);
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot3, 2);
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot4, 3);
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot5, 4);
                SetItemDisplayText(shopKeeper.keeperInventory.shopInventory, inventorySlot6, 5);
                break;
            case Sell:
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot1, 0);
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot2, 1);
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot3, 2);
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot4, 3);
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot5, 4);
                SetItemDisplayText(shopKeeper.keeperInventory.creatureInfo.pet.inventory, inventorySlot6, 5);
                break;
            case Upgrade:
                break;
        }
    }

    void SetItemDisplayText(Item []array, TextView text, int index) {
        if (array == shopKeeper.keeperInventory.shopInventory && array[index] != null) {
            text.setText(array[index].GetName() + "  " + array[index].GetCost());
        }

        else if (array == shopKeeper.keeperInventory.creatureInfo.pet.inventory && array[index] != null){
            text.setText(array[index].GetName() + "  " + array[index].GetCost() * 0.6);
        }

        else if (array == shopKeeper.keeperInventory.creatureInfo.pet.inventory && array[index] == null)
            text.setText(" ");
    }

}
