package com.example.adventurepocket;

import android.util.Log;

class TimeOfDay
{
    private static TimeOfDay iTimeOfDay = null;
    int MAX_TURNS_PER_DAY;
    private int turnCount;
    private boolean timesUp;
    int daysPassed = 1;

    static TimeOfDay TimeofDay()
    {
        // To ensure only one instance is created
        if (iTimeOfDay == null)
        {
            iTimeOfDay = new TimeOfDay();
        }
        return iTimeOfDay;
    }

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     *                                                                   *
     * okay so how this gonna work Jeff.                                 *
     * Time of Day                                                       *
     * we have X Actions in a day, or X Turns                            *
     * Every Action will add one to the turn count                       *
     * if the turnCount is equal to the maxTurnCount the pet passes out  *
     * When the player Rests a Day will pass and                         *
     * the turnCount is Reduced by 8.                                    *
     * When the Player Passes out, A Day will pas and                    *
     * the turn Count is Reduced b 4.                                    *
     *                                                                   *
     * ## In the Future I want to add in a Proper clock, Where some Pets *
     * like being awake at night, while others in the day,               *
     * Right now if feels super rigid and just feels bad                 *
     *                                                                   *
     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
    void TimeOfDaySetup(int _turnsInDay)
    {
        MAX_TURNS_PER_DAY = _turnsInDay;
        daysPassed = 1;
        SetTurnCount(6);
    }
    int GetTurnCount()
    {
        return turnCount;
    }
    void SetTurnCount(int _value)
    {
        turnCount = _value;
    }
    void AddTurnCount(int _value)
    {
        turnCount += _value;
    }

    boolean CheckPassOut()
    {
        if(turnCount >= MAX_TURNS_PER_DAY)
        {
            timesUp = true;
        }
        else
        {
            timesUp = false;
        }
        if(timesUp) {
            daysPassed += 1;
            turnCount = 12;

            Log.i("Info", " Day : " + daysPassed );
            Log.i("Info", turnCount + "/" + MAX_TURNS_PER_DAY);
        }
        return timesUp;
    }

}
