package com.example.adventurepocket;

public class CreatureManager extends TimeOfDay
{
    private static CreatureManager iCreatureManager = null;
    private int gold = 100;

    Creature pet;
    private CreatureManager() {

        pet = new Creature();
        setGold(100);
        TimeOfDaySetup(24);
    }
    static CreatureManager iCreatureManager() {
        if (iCreatureManager == null) {
            iCreatureManager = new CreatureManager();
        }
        return iCreatureManager;
    }

    private void ResetPetInfo(){
        gold = 0;
        daysPassed = 0;
    }
    void OnDeath()
    {
        ResetPetInfo();
        pet.ResetCreature();
    }

    public int getGold() {
        return gold;
    }

    public void setGold(int gold) {
        this.gold = gold;
    }
    void addGold(int _value)
    {
        gold += _value;
    }
    void removeGold(int _value)
    {
        gold -= _value;
    }
}
