package com.example.adventurepocket;

public class Item{
    private String _name;
    private int _costValue;
    private int _statValue;

    Item(String name, int statValue, int costValue) {
        _name = name;
        _statValue = statValue;
        _costValue = costValue;
    }

    public static class Sword extends Item {
        Sword(String name, int attack, int cost) {
            super(name, attack, cost);
        }
    }

    public static class Shield extends Item {
        Shield(String name, int defense, int cost) {
            super(name, defense, cost);
        }
    }

    public static class Food extends Item {
        Food(String name, int restoreValue, int cost) {
            super(name, restoreValue, cost);
        }
    }

    String GetName() {
        return _name;
    }

    int GetStat() {
        return _statValue;
    }

    int GetCost() {
        return _costValue;
    }

}
