package com.example.adventurepocket;

import android.view.SurfaceHolder;

public class ShopThread extends Thread {
    public static boolean isGameRunning;
    private SurfaceHolder currentHolder;

    long startTime;
    long endTime;
    float deltaTimeSeconds;
    public final int TARGET_FPS = 60;
    public static int ACTUAL_FPS = 0;
    private ShopManager currentShopState;

    public void activateShopThread(ShopManager state) {
        isGameRunning = true;
        currentShopState = state;
        this.start();
    }

    public void run() {
        while (isGameRunning) {
            startTime = System.currentTimeMillis();

            currentShopState.updateState(deltaTimeSeconds);

            endTime = System.currentTimeMillis();
            long delta = endTime - startTime;
            deltaTimeSeconds = (float) delta / 1000;

            //hybrid system begins
            if (delta < 1000) {
                long interval = (1000 - delta) / TARGET_FPS;
                ACTUAL_FPS = TARGET_FPS;
                try {
                    Thread.sleep(interval);
                } catch (Exception ex) {

                }
            } else {
                ACTUAL_FPS = (int) (1000 / delta);
            }
            //hybrid system ends
        }
    }
}
